<?php
function dawn_form_system_theme_settings_alter(&$form, &$form_state) {

  drupal_add_css(drupal_get_path('theme', 'dawn'). '/css/dawn-appearance.css', array('weight' => 110, 'group' => CSS_THEME));

  $grids =  drupal_map_assoc(range (1,12));
  foreach($grids as $k => $v){
    $grids[$k] = t('!num Columns', array('!num'=>$v));
  }

  $form['fluid'] = array(
     '#type' => 'fieldset',
     '#title' => t('Fluid Regions'),
   );
  $form['fluid']['fluid_header'] = array(
    '#type' => 'checkbox',
    '#title' => t('Header'),
    '#default_value' => theme_get_setting('fluid_header'),
  );
  $form['fluid']['fluid_content'] = array(
    '#type' => 'checkbox',
    '#title' => t('Content'),
    '#default_value' => theme_get_setting('fluid_content'),
  );
  $form['fluid']['fluid_footer'] = array(
    '#type' => 'checkbox',
    '#title' => t('Footer'),
    '#default_value' => theme_get_setting('fluid_footer'),
  );
  $theme_name = arg(3);
  $theme_info = system_get_info('theme', $theme_name);

  $block_demo = l($theme_info['name'].' Block Demo','admin/structure/block/demo/'.$theme_name, array('attributes' => array('target' =>'_blank')));
  $form['grids'] = array(
   '#type' => 'fieldset',
   '#title' => t('@theme Content & Sidebar Grid Widths', array('@theme'=>$theme_info['name'])),
   '#description' => t(<<<EOF
<dl>
<dd class="block-demo-link">$block_demo</dd>
<dt>How to <q>Add Your Columns Up</q>:  </dt>
<dd>
<ul>
<li>Sidebar First and Content are within their own row (on page.tpl.php this is the <q>grid_main</q> row).  <strong>These TWO REGIONS should add up to 12 for each breakpoint </strong>.</li>
<li>As for Sidebar Second, it's width is used against <q>grid_main</q> width (which contains Sidebar First and Content regions).</li>
<li>XS Breakpoint will degrade to 12 for all columns.</li>
<li>Each column is 1/12 of the row width, as to be expected from Bootstrap.</li>
</ul>
</dd>
</dl>
EOF
),
  );

    $form['grids']['sm'] = array(
     '#type' => 'fieldset',
     '#title' => t('Breakpoint SM'),
    );
      $form['grids']['sm']['grid_sidebar_first_sm'] = array(
       '#type' => 'select',
       '#title' => t('Sidebar First'),
       '#default_value' => theme_get_setting('grid_sidebar_first_sm'),
       '#options' => $grids
      );
      $form['grids']['sm']['grid_content_sm'] = array(
       '#type' => 'select',
       '#title' => t('Content'),
       '#default_value' => theme_get_setting('grid_content_sm'),
       '#options' => $grids
      );
      $form['grids']['sm']['grid_sidebar_second_sm'] = array(
       '#type' => 'select',
       '#title' => t('Sidebar Second'),
       '#default_value' => theme_get_setting('grid_sidebar_second_sm'),
       '#options' => $grids
      );

    $form['grids']['md'] = array(
     '#type' => 'fieldset',
     '#title' => t('Breakpoint Medium'),
    );
      $form['grids']['md']['grid_sidebar_first_md'] = array(
       '#type' => 'select',
       '#title' => t('Sidebar First'),
       '#default_value' => theme_get_setting('grid_sidebar_first_md'),
       '#options' => $grids
      );
      $form['grids']['md']['grid_content_md'] = array(
       '#type' => 'select',
       '#title' => t('Content'),
       '#default_value' => theme_get_setting('grid_content_md'),
       '#options' => $grids
      );
      $form['grids']['md']['grid_sidebar_second_md'] = array(
       '#type' => 'select',
       '#title' => t('Sidebar Second'),
       '#default_value' => theme_get_setting('grid_sidebar_second_md'),
       '#options' => $grids
      );

    $form['grids']['lg'] = array(
     '#type' => 'fieldset',
     '#title' => t('Breakpoint Large'),
    );
      $form['grids']['lg']['grid_sidebar_first_lg'] = array(
       '#type' => 'select',
       '#title' => t('Sidebar First'),
       '#default_value' => theme_get_setting('grid_sidebar_first_lg'),
       '#options' => $grids
      );
      $form['grids']['lg']['grid_content_lg'] = array(
       '#type' => 'select',
       '#title' => t('Content'),
       '#default_value' => theme_get_setting('grid_content_lg'),
       '#options' => $grids
      );
      $form['grids']['lg']['grid_sidebar_second_lg'] = array(
       '#type' => 'select',
       '#title' => t('Sidebar Second'),
       '#default_value' => theme_get_setting('grid_sidebar_second_lg'),
       '#options' => $grids
      );


  $form['grids']['footer'] = array(
    '#type'=>'markup',
    '#markup'=>'
<dl>
<dt>Breakpoint Overview</dt>
<ol>
<li><mark>xs</mark> for phones - screens less than 768px wide <small>(no container width)</small></li>
<li><mark>sm</mark> for tablets - screens equal to or greater than 768px wide  <small>(750px container width)</small></li>
<li><mark>md</mark> for small laptops - screens equal to or greater than 992px wide  <small>(970px container width)</small></li>
<li><mark>lg</mark> for laptops and desktops - screens equal to or greater than 1200px wide <small>(1170px container width)</small></li>
</ol>
</dd>
</dl>
');
  $form['libraries'] = array(
    '#type' => 'fieldset',
    '#title' => t('Additional Tools'),
  );
  $form['libraries']['html_shim'] = array(
    '#type' => 'checkbox',
    '#title' => t('html5 Shim'),
    '#default_value' => theme_get_setting('html_shim'),
    '#description' => t('Add html5 shim to header (Uses CDN). For projects that need to support older browsers which lack html5 tags (Section, Menu, Header, Footer, Aside)')
  );
  $rdf_status= module_exists('rdf');
  $rdf = t('RDF module is offline.  HTML tag outputing basic doctype.');
  if ($rdf_status){
      $rdf = t('RDF module is online. HTML tag outputing related information.');
  }
  $form['libraries']['doctype'] = array(
    '#type' => 'markup',
    '#markup' =>'<dl><dt>'. t('General Notice:').'</dt><dd>'.$rdf. '</dd></dl>'
  );


  $form['meta'] = array(
    '#type'  => 'fieldset',
    '#title' => t('HTML Meta'),
  );
  $form['meta']['meta_httpequiv'] = array(
    '#type' => 'textfield',
    '#title' => t('http-equiv'),
    '#default_value' => theme_get_setting('meta_httpequiv'),
    '#description' => t('Key: httpequiv')
  );
  $form['meta']['meta_viewport'] = array(
    '#type' => 'textfield',
    '#title' => t('viewport'),
    '#default_value'=> theme_get_setting('meta_viewport'),
    '#description' => t('Key: viewport')
  );
  $form['meta']['override'] = array(
    '#type' => 'markup',
    '#markup' =>'<ul>
<li>'.t('Empty fields will bypass item from output.').'</li>
<li>'. t('Developer Note:  Use <a href="@url" target="_blank">drupal_add_html_head()</a> to override.  In your modules use <q>$key</q> shown above.', array('@url'=>url('https://api.drupal.org/api/drupal/includes%21common.inc/function/drupal_add_html_head/7.x'))).'</li>
</ul>',
  );

 $form['#validate'][] = 'dawn_theme_settings_validate';

}

function dawn_theme_settings_validate($form, $form_state){
	$grid_sidebar_first_sm = intval($form_state['values']['grid_sidebar_first_sm']);
	$grid_content_sm = intval($form_state['values']['grid_content_sm']);
  if ( ($grid_sidebar_first_sm+$grid_content_sm) !=12){
    form_set_error('grid_sidebar_first_sm', t('Sidebar First SM: total is not equal to 12'));
    form_set_error('grid_content_sm', t('Content SM: total is not equal to 12'));
  }

	$grid_sidebar_first_md = intval($form_state['values']['grid_sidebar_first_md']);
	$grid_content_md = intval($form_state['values']['grid_content_md']);
  if ( ($grid_sidebar_first_md+$grid_content_md) !=12){
    form_set_error('grid_sidebar_first_md', t('Sidebar First MD:  total is not equal to 12'));
    form_set_error('grid_content_md', t('Content MD: total is not equal to 12'));
  }

	$grid_sidebar_first_lg = intval($form_state['values']['grid_sidebar_first_lg']);
	$grid_content_lg = intval($form_state['values']['grid_content_lg']);
  if ( ($grid_sidebar_first_lg+$grid_content_lg) !=12){
    form_set_error('grid_sidebar_first_lg', t('Sidebar First LG: total is not equal to 12'));
    form_set_error('grid_content_lg', t('Content LG: total is not equal to 12'));
  }
}
